#cs
Revisions
---------
13_Jun-11	Added chkTaskbar (WS_EX_APPWINDOW), WS_EX_STATICEDGE; ShowAllStyles(): fixed stupid bug
12-Jun-11	Corrected hint for $chkDoubleBorder: was WS_EX_DLGFRAME npw WS_DLGFRAME
11-Jun-11	Corrected WS_EX_WINDOWEDGE from Raised edge to Raised client area
02-Jun-11	Added Hints for Presets
01-Jun-11	Added Form has Parent property; added Hints for checkboxes
31-May-11	Reorganized the code and GUI; added styles and exStyles that Koda does not have now.

#ce
#include <ButtonConstants.au3>
#include <Constants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <ListBoxConstants.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <..\cdebug.au3>
Opt("MustDeclareVars",1)
Opt("TrayIconDebug",1)
Global $gParamStyles,$gParamExStyles	; styles and exStyles parameter of GuiCreate
Global $presetStylesAr[10][2]
$presetStylesAr[1][0] = BitOR($WS_MINIMIZEBOX, $WS_CAPTION, $WS_POPUP, $WS_SYSMENU)	; -1
$presetStylesAr[1][1] = 0
$presetStylesAr[2][0] = BitOR($WS_POPUP, $WS_BORDER, $WS_SYSMENU, $WS_CAPTION)
$presetStylesAr[2][1] = $WS_EX_CONTEXTHELP
$presetStylesAr[3][0] = $WS_POPUP
$presetStylesAr[3][1] = 0
$presetStylesAr[4][0] = BitOR($WS_DLGFRAME,$WS_BORDER) ; 0
$presetStylesAr[4][1] = 0
$presetStylesAr[5][0] = BitOR($WS_DLGFRAME, $WS_CAPTION, $WS_HSCROLL) ; $WS_HSCROLL
$presetStylesAr[5][1] = 0
$presetStylesAr[6][0] = BitOR($WS_POPUPWINDOW, $WS_DLGFRAME)
$presetStylesAr[6][1] = 0
$presetStylesAr[7][0] = BitOR($WS_SIZEBOX,$WS_SYSMENU,$WS_CAPTION) ; $WS_SIZEBOX
$presetStylesAr[7][1] = 0
;                       WS_OVERLAPPEDWINDOW
$presetStylesAr[8][0] = BitOR($WS_OVERLAPPED, $WS_CAPTION, $WS_SYSMENU, $WS_SIZEBOX, $WS_MINIMIZEBOX, $WS_MAXIMIZEBOX)
$presetStylesAr[8][1] = 0
$presetStylesAr[9][0] = BitOR($WS_MINIMIZEBOX, $WS_CAPTION, $WS_POPUP, $WS_SYSMENU) ; -1
$presetStylesAr[9][1] = $WS_EX_CONTEXTHELP
Global Const $kStylesAr[15][2] = [[$WS_BORDER,"$WS_BORDER"], [$WS_CHILD,"$WS_CHILD"], [$WS_CLIPCHILDREN,"$WS_CLIPCHILDREN"], _
	[$WS_CLIPSIBLINGS,"$WS_CLIPSIBLINGS"], [$WS_DLGFRAME,"$WS_DLGFRAME"], [$WS_HSCROLL,"$WS_HSCROLL"], _
	[$WS_MAXIMIZE,"$WS_MAXIMIZE"], [$WS_MAXIMIZEBOX,"$WS_MAXIMIZEBOX"], [$WS_MINIMIZE,"$WS_MINIMIZE"], _
	[$WS_MINIMIZEBOX,"$WS_MINIMIZEBOX"], [$DS_MODALFRAME,"$DS_MODALFRAME"], [$WS_POPUP,"$WS_POPUP"], [$WS_SIZEBOX,"$WS_SIZEBOX"], _
	[$WS_SYSMENU,"$WS_SYSMENU"], [$WS_VSCROLL,"$WS_VSCROLL"]]
; AutoIt lacks $WS_PALETTEWINDOW = BitOR($WS_EX_WINDOWEDGE, $WS_EX_TOPMOST)
Global Const $kBCCstylesAr[3][2] = [[$WS_CAPTION,"$WS_CAPTION"], [$WS_OVERLAPPEDWINDOW,"$WS_OVERLAPPEDWINDOW"], _
	[$WS_POPUPWINDOW,"$WS_POPUPWINDOW"]]	; BCC = bit-comnination constants

Global Const $kExStylesAr[17][2] = [[$WS_EX_ACCEPTFILES,"$WS_EX_ACCEPTFILES"], [$WS_EX_CLIENTEDGE,"$WS_EX_CLIENTEDGE"], _
	[$WS_EX_COMPOSITED,"$WS_EX_COMPOSITED"], [$WS_EX_CONTEXTHELP,"$WS_EX_CONTEXTHELP"], _
	[$WS_EX_CONTROLPARENT,"$WS_EX_CONTROLPARENT"], [$WS_EX_DLGMODALFRAME,"$WS_EX_DLGMODALFRAME"], _
	[$WS_EX_LAYERED,"$WS_EX_LAYERED"], [$WS_EX_LEFTSCROLLBAR,"$WS_EX_LEFTSCROLLBAR"], [$WS_EX_MDICHILD,"$WS_EX_MDICHILD"], _
	[$WS_EX_RIGHT,"$WS_EX_RIGHT"], [$WS_EX_RTLREADING,"$WS_EX_RTLREADING"], [$WS_EX_TRANSPARENT,"$WS_EX_TRANSPARENT"], _
	[$WS_EX_TOOLWINDOW,"$WS_EX_TOOLWINDOW"], [$WS_EX_TOPMOST,"$WS_EX_TOPMOST"],	[$WS_EX_WINDOWEDGE,"$WS_EX_WINDOWEDGE"], _
	[$WS_EX_APPWINDOW,"$WS_EX_APPWINDOW"],[$WS_EX_STATICEDGE,"$WS_EX_STATICEDGE"]]
Global Const $kBCCexStylesAr[1][2] = [[$WS_EX_OVERLAPPEDWINDOW,"$WS_EX_OVERLAPPEDWINDOW"]]
#Region ### START Koda GUI section ### Form=F:\AutoIt scripts\Koda devel\Styles with presets suggestion.kxf
Local $frmFormStyles = GUICreate("Styles: Form", 821, 532, -1, -1, 0)
Local $lblStatus = GUICtrlCreateLabel("Preset", 400, 184, 181, 17, $SS_CENTER)
GUICtrlSetFont(-1, 9, 800, 0, "MS Serif")
GUICtrlSetColor(-1, 0x008000)
Local $gpPresets = GUICtrlCreateGroup("Presets", 8, 8, 177, 169)
Local $radPreset01 = GUICtrlCreateRadio("1", 16, 26, 65, 17)
GUICtrlSetState(-1, $GUI_CHECKED)
GUICtrlSetTip(-1, "System menu, Caption, Minimze box, Close box")
Local $radPreset02 = GUICtrlCreateRadio("2", 16, 44, 65, 17)
GUICtrlSetTip(-1, "System menu, Caption, Context help box, Close box")
Local $radPreset03 = GUICtrlCreateRadio("3", 16, 62, 65, 17)
GUICtrlSetTip(-1, "only Client area")
Local $radPreset04 = GUICtrlCreateRadio("4", 16, 80, 65, 17)
GUICtrlSetTip(-1, "Caption")
Local $radPreset05 = GUICtrlCreateRadio("5", 16, 98, 65, 17)
GUICtrlSetTip(-1, "Caption, Horizontal scroll bar")
Local $radPreset06 = GUICtrlCreateRadio("6", 16, 116, 65, 17)
GUICtrlSetTip(-1, "System menu, Caption, Close box")
Local $radNone = GUICtrlCreateRadio("None", 64, 152, 65, 17)
Local $radPreset08 = GUICtrlCreateRadio("8", 95, 26, 65, 17)
GUICtrlSetTip(-1, "System menu, Caption, Minimze box, Maximize box, Close box")
Local $radPreset09 = GUICtrlCreateRadio("9", 95, 44, 65, 17)
GUICtrlSetTip(-1, "System menu, Caption, Context help box, Minimize box, Close box")
Local $radPreset10 = GUICtrlCreateRadio("10", 95, 62, 65, 17)
GUICtrlSetTip(-1, "-- not yet defined --")
Local $radPreset11 = GUICtrlCreateRadio("11", 95, 80, 65, 17)
GUICtrlSetTip(-1, "-- not yet defined --")
Local $radPreset12 = GUICtrlCreateRadio("12", 95, 98, 65, 17)
GUICtrlSetTip(-1, "- not yet defined --")
Local $radPreset13 = GUICtrlCreateRadio("13", 95, 116, 65, 17)
GUICtrlSetTip(-1, "-- not yet defined --")
Local $radPreset07 = GUICtrlCreateRadio("7", 16, 136, 65, 17)
GUICtrlSetTip(-1, "System menu, Caption, Close box, Resizable")
Local $radPreset14 = GUICtrlCreateRadio("14", 95, 132, 65, 17)
GUICtrlSetTip(-1, "-- not yet defined --")
GUICtrlCreateGroup("", -99, -99, 1, 1)
Local $btnOK = GUICtrlCreateButton("OK", 712, 476, 41, 25)
Local $btnCancel = GUICtrlCreateButton("Cancel", 763, 476, 41, 25)
GUICtrlCreateLabel("AutoIt style parameter", 8, 360, 106, 17)
GUICtrlCreateLabel("AutoIt exStyle parameter", 200, 360, 119, 17)
GUICtrlCreateLabel("Parameters including forced", 400, 209, 135, 17, $WS_CLIPSIBLINGS)
GUICtrlCreateLabel("AutoIt or Windows ignored", 400, 328, 129, 17)
GUICtrlCreateLabel("Autoit or Windows added", 401, 385, 123, 17)
Local $gpTitleBar = GUICtrlCreateGroup("Title Bar", 8, 184, 177, 153)
Local $chkSysMenu = GUICtrlCreateCheckbox("System menu", 21, 202, 97, 17)
GUICtrlSetTip(-1, "$WS_SYSMENU")
Local $chkCaption = GUICtrlCreateCheckbox("Caption", 21, 220, 81, 17)
GUICtrlSetTip(-1, "$WS_CAPTION")
Local $chkCtxHelp = GUICtrlCreateCheckbox("Context help", 21, 238, 105, 17)
GUICtrlSetTip(-1, "$WS_EX_CONTEXTHELP")
Local $chkMinBox = GUICtrlCreateCheckbox("Minimize box", 21, 256, 105, 17)
GUICtrlSetTip(-1, "$WS_MINIMIZEBOX")
Local $chkMaxBox = GUICtrlCreateCheckbox("Maximize box", 21, 274, 105, 17)
GUICtrlSetTip(-1, "$WS_MAXIMIZEBOX")
Local $chkCloseBox = GUICtrlCreateCheckbox("Close box", 21, 292, 89, 17)
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlSetTip(-1, "-- no constant --")
Local $chkResizeable = GUICtrlCreateCheckbox("Resizable", 21, 310, 97, 17)
GUICtrlSetTip(-1, "$WS_SIZEBOX")
GUICtrlCreateGroup("", -99, -99, 1, 1)
Local $gpAppearance = GUICtrlCreateGroup("Appearance", 200, 8, 185, 257)
Local $chkHorizScroll = GUICtrlCreateCheckbox("Horizontal scroll bar", 210, 26, 121, 17)
GUICtrlSetTip(-1, "$WS_HSCROLL")
Local $chkVertScroll = GUICtrlCreateCheckbox("Vertical scroll bar", 210, 43, 121, 17)
GUICtrlSetTip(-1, "$WS_VSCROLL")
Local $chkThinBorder = GUICtrlCreateCheckbox("Thin-line border", 210, 61, 105, 17)
GUICtrlSetTip(-1, "$WS_BORDER")
Local $chkDoubleBorder = GUICtrlCreateCheckbox("Double-line border", 210, 79, 113, 17)
GUICtrlSetTip(-1, "$WS_EX_DLGMODALFRAME")
Local $chkRaisedClient = GUICtrlCreateCheckbox("Raised client area", 210, 93, 116, 17)
GUICtrlSetTip(-1, "$WS_EX_WINDOWEDGE")
Local $chkSunkenClient = GUICtrlCreateCheckbox("Sunken client area", 210, 111, 121, 17)
GUICtrlSetTip(-1, "$WS_EX_CLIENTEDGE")
Local $chkToolBar = GUICtrlCreateCheckbox("Form is toolbar", 210, 129, 145, 17)
GUICtrlSetTip(-1, "$WS_EX_TOOLWINDOW")
Local $chkTransparent = GUICtrlCreateCheckbox("Form is transparent", 210, 147, 121, 17)
GUICtrlSetTip(-1, "$WS_EX_TRANSPARENT")
Local $chkAvoidClipChildren = GUICtrlCreateCheckbox("Avoid clipping children", 210, 165, 137, 17)
GUICtrlSetTip(-1, "$WS_CLIPCHILDREN")
Local $chkMaximize = GUICtrlCreateCheckbox("Maximize initially", 210, 183, 121, 17)
GUICtrlSetTip(-1, "$WS_MAXIMIZE")
Local $chkMinimize = GUICtrlCreateCheckbox("Minimize initially", 210, 201, 121, 17)
GUICtrlSetTip(-1, "$WS_MINIMIZE")
Local $chkOnTop = GUICtrlCreateCheckbox("Always on top", 211, 219, 97, 17)
GUICtrlSetTip(-1, "$WS_EX_TOPMOST")
Local $chkLayered = GUICtrlCreateCheckbox("Layered effects", 210, 237, 97, 17)
GUICtrlSetTip(-1, "$WS_EX_LAYERED")
GUICtrlCreateGroup("", -99, -99, 1, 1)
Local $gpLanguage = GUICtrlCreateGroup("Right-to-left Languages", 200, 272, 185, 81)
Local $chkScrollLeft = GUICtrlCreateCheckbox("Scroll bars are on left/bottom", 211, 290, 161, 17)
GUICtrlSetTip(-1, "$WS_EX_LEFTSCROLLBAR")
Local $chkTextRight = GUICtrlCreateCheckbox("Right-aligned text", 211, 308, 145, 17)
GUICtrlSetTip(-1, "$WS_EX_RIGHT")
Local $chkRightToLeft = GUICtrlCreateCheckbox("Right-to-left reading order", 211, 326, 145, 17)
GUICtrlSetTip(-1, "$WS_EX_RTLREADING")
GUICtrlCreateGroup("", -99, -99, 1, 1)
Local $gpMisc = GUICtrlCreateGroup("Miscellaneous", 400, 16, 401, 121)
Local $chkChild = GUICtrlCreateCheckbox("Child", 410, 52, 105, 17)
GUICtrlSetTip(-1, "$WS_CHILD")
Local $chkModal = GUICtrlCreateCheckbox("Modal", 410, 70, 65, 17)
GUICtrlSetTip(-1, "$DS_MODALFRAME")
Local $chkDoubleBuffer = GUICtrlCreateCheckbox("Double-buffer to reduce flicker", 410, 88, 165, 17)
GUICtrlSetTip(-1, "$WS_EX_COMPOSITED")
Local $chkAccept = GUICtrlCreateCheckbox("Accept filenames in Input/Edit", 594, 34, 165, 17)
GUICtrlSetTip(-1, "$WS_EX_ACCEPTFILES")
Local $chkMDI = GUICtrlCreateCheckbox("Simulate MDI", 594, 52, 145, 17)
GUICtrlSetTip(-1, "$WS_EX_MDICHILD")
Local $chkTabNavsChildren = GUICtrlCreateCheckbox("Tab key navigates among children", 594, 75, 145, 25, BitOR($GUI_SS_DEFAULT_CHECKBOX,$BS_MULTILINE))
GUICtrlSetTip(-1, "$WS_EX_CONTROLPARENT")
Local $chkPopup = GUICtrlCreateCheckbox("Popup", 410, 34, 129, 17)
GUICtrlSetTip(-1, "WS_POPUP")
Local $chkTaskbar = GUICtrlCreateCheckbox("Form appears in task bar", 410, 106, 165, 17)
GUICtrlSetTip(-1, "$WS_EX_APPWINDOW")
GUICtrlCreateGroup("", -99, -99, 1, 1)
Local $lstAIstylesInclForced = GUICtrlCreateList("", 400, 224, 185, 97, BitOR($LBS_NOTIFY,$WS_HSCROLL,$WS_VSCROLL,$WS_BORDER))
Local $lstStylesWinIgnored = GUICtrlCreateList("", 400, 344, 185, 32, BitOR($LBS_NOTIFY,$WS_HSCROLL,$WS_VSCROLL,$WS_BORDER))
Local $lstStylesWinAdded = GUICtrlCreateList("", 400, 404, 185, 45, BitOR($LBS_NOTIFY,$WS_HSCROLL,$WS_VSCROLL,$WS_BORDER))
Local $lstStyleParam = GUICtrlCreateList("", 8, 376, 177, 84, BitOR($LBS_NOTIFY,$WS_HSCROLL,$WS_VSCROLL,$WS_BORDER))
Local $lstExStyleParam = GUICtrlCreateList("", 200, 376, 185, 84, BitOR($LBS_NOTIFY,$WS_HSCROLL,$WS_VSCROLL,$WS_BORDER))
Local $chkFormHasParentProperty = GUICtrlCreateCheckbox("Form has ParentForm  property", 472, 480, 177, 17)
GUICtrlSetState(-1, $GUI_CHECKED)
GUICtrlSetFont(-1, 8, 400, 2, "MS Sans Serif")
Local $chkShowBitCombConsts = GUICtrlCreateCheckbox("Show bit-combination constants", 216, 480, 169, 17)
GUICtrlSetFont(-1, 8, 400, 2, "MS Sans Serif")
Local $gpTest = GUICtrlCreateGroup("Test", 601, 220, 185, 169)
GUICtrlCreateLabel("Show time", 627, 250, 59, 17)
GUICtrlSetFont(-1, 8, 400, 2, "MS Sans Serif")
Local $inpShowTestSecs = GUICtrlCreateInput("2", 687, 248, 38, 21, BitOR($GUI_SS_DEFAULT_INPUT,$ES_RIGHT,$ES_READONLY))
GUICtrlSetBkColor(-1, 0xFFFFFF)
Local $Updown1 = GUICtrlCreateUpdown($inpShowTestSecs)
GUICtrlSetLimit(-1, 30, 1)
GUICtrlCreateLabel("secs", 731, 250, 32, 17)
GUICtrlSetFont(-1, 8, 400, 2, "MS Sans Serif")
Local $chkShowTestForm = GUICtrlCreateCheckbox("Show", 709, 280, 57, 17, BitOR($GUI_SS_DEFAULT_CHECKBOX,$BS_PUSHLIKE))
GUICtrlSetFont(-1, 8, 400, 2, "MS Sans Serif")
GUICtrlCreateGroup("", -99, -99, 1, 1)
GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###

Const $allChksVec[30] = [$chkAccept, $chkAvoidClipChildren, $chkCaption, $chkChild, $chkCloseBox, $chkCtxHelp, $chkDoubleBuffer, _
	$chkDoubleBorder, $chkHorizScroll, $chkMaxBox, $chkMaximize, $chkMDI, $chkMinBox, $chkMinimize, $chkModal, $chkOnTop, _
	$chkRaisedClient, $chkResizeable, $chkRightToLeft, $chkScrollLeft, $chkSunkenClient, $chkSysMenu, $chkTabNavsChildren, _
	$chkTextRight, $chkThinBorder, $chkToolBar, $chkTransparent, $chkVertScroll, $chkLayered, $chkPopup]
DoPreset(1)
;AutoIt_Debugger_Command:Disable_Debug
While 1
	Local $nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE,$btnCancel,$btnOK
			Exit
		Case $chkAccept
			DoCheckBox($nMsg,0,$WS_EX_ACCEPTFILES)
		Case $chkAvoidClipChildren
			DoCheckBox($nMsg,$WS_CLIPCHILDREN,0)
		Case $chkCaption
			DoCheckBox($nMsg,$WS_CAPTION,0)
		Case $chkChild
			DoCheckBox($nMsg,$WS_CHILD,0)
		Case $chkCloseBox
			; do nothing
		Case $chkCtxHelp
			DoCheckBox($nMsg,0,$WS_EX_CONTEXTHELP)
		Case $chkDoubleBorder
			DoCheckBox($nMsg,$WS_DLGFRAME,0)
;			DoCheckBox($nMsg,0,$WS_EX_DLGMODALFRAME)
		Case $chkDoubleBuffer
			DoCheckBox($nMsg,0,$WS_EX_COMPOSITED)
		Case $chkHorizScroll
			DoCheckBox($nMsg,$WS_HSCROLL,0)
		Case $chkLayered
			DoCheckBox($nMsg,0,$WS_EX_LAYERED)
		Case $chkMaxBox
			DoCheckBox($nMsg,$WS_MAXIMIZEBOX,0)
		case $chkMaximize
			DoCheckBox($nMsg,$WS_MAXIMIZE,0)
		Case $chkMDI
			DoCheckBox($nMsg,0,$WS_EX_MDICHILD)
		Case $chkMinBox
			DoCheckBox($nMsg,$WS_MINIMIZEBOX,0)
		Case $chkMinimize
			DoCheckBox($nMsg,$WS_MINIMIZE,0)
		Case $chkModal
			DoCheckBox($nMsg,0,$WS_EX_DLGMODALFRAME)
;			DoCheckBox($nMsg,$DS_MODALFRAME,0)
		Case $chkOnTop
			DoCheckBox($nMsg,0,$WS_EX_TOPMOST)
		Case $chkPopup
			DoCheckBox($nMsg,$WS_POPUP,0)
		Case $chkRaisedClient
			DoCheckBox($nMsg,0,$WS_EX_WINDOWEDGE)
		Case $chkResizeable
			DoCheckBox($nMsg,$WS_SIZEBOX,0)
		Case $chkRightToLeft
			DoCheckBox($nMsg,0,$WS_EX_RTLREADING)
		Case $chkScrollLeft
			DoCheckBox($nMsg,0,$WS_EX_LEFTSCROLLBAR)
		Case $chkSunkenClient
			DoCheckBox($nMsg,0,$WS_EX_CLIENTEDGE)
		Case $chkSysMenu
			DoCheckBox($nMsg,$WS_SYSMENU,0)
		Case $chkTabNavsChildren
			DoCheckBox($nMsg,0,$WS_EX_CONTROLPARENT)
		case $chkTaskbar
			DoCheckBox($nMsg,0,$WS_EX_APPWINDOW)
		Case $chkTextRight
			DoCheckBox($nMsg,0,$WS_EX_RIGHT)
		Case $chkThinBorder
			DoCheckBox($nMsg,$WS_BORDER,0)
		Case $chkToolBar
			DoCheckBox($nMsg,0,$WS_EX_TOOLWINDOW)
		Case $chkTransparent
			DoCheckBox($nMsg,0,$WS_EX_TRANSPARENT)
		Case $chkVertScroll
			DoCheckBox($nMsg,$WS_VSCROLL,0)
		Case $chkShowTestForm,$chkFormHasParentProperty,$chkShowBitCombConsts
			Show()
		Case $inpShowTestSecs
			If GUICtrlRead($inpShowTestSecs)>0 Then
				GUICtrlSetState($chkShowTestForm,$GUI_ENABLE)
			Else
				GUICtrlSetState($chkShowTestForm,$GUI_UNCHECKED)
				GUICtrlSetState($chkShowTestForm,$GUI_DISABLE)
			EndIf
		Case $radPreset01
			DoPreset(1)
		Case $radPreset02
			DoPreset(2)
		Case $radPreset03
			DoPreset(3)
		Case $radPreset04
			DoPreset(4)
		Case $radPreset05
			DoPreset(5)
		Case $radPreset06
			DoPreset(6)
		Case $radPreset07
			DoPreset(7)
		Case $radPreset08
			DoPreset(8)
		Case $radPreset09
			DoPreset(9)
		Case $radPreset10
			DoPreset(10)
		Case $radPreset11
			DoPreset(11)
		Case $radPreset12
			DoPreset(12)
		Case $radPreset13
			DoPreset(13)
		Case $radPreset14
			DoPreset(14)
		Case $radNone
			DoPreset(0)
	EndSwitch
WEnd
;AutoIt_Debugger_Command:Enable_Debug

Func DoPreset($nPres)
	Switch $nPres
	Case 1
		Local $chksVec[6] = [$chkSysMenu,$chkCaption,$chkMinBox,$chkCloseBox,$chkPopup]
	Case 2
		Local $chksVec[5] = [$chkSysMenu,$chkCaption,$chkCloseBox,$chkCtxHelp]
	Case 3
		Local $chksVec[1] = [$chkPopup]
	Case 4
		Local $chksVec[1] = [$chkCaption]
	Case 5
		Local $chksVec[2] =[$chkCaption,$chkHorizScroll]
	Case 6
		Local $chksVec[3] = [$chkSysMenu,$chkCaption,$chkCloseBox]
	Case 7
		Local $chksVec[4] = [$chkSysMenu,$chkCaption,$chkCloseBox,$chkResizeable]
	Case 8
		Local $chksVec[5] = [$chkSysMenu,$chkCaption,$chkMinBox,$chkMaxBox,$chkCloseBox]
	Case 9
		Local $chksVec[5] = [$chkSysMenu,$chkCaption,$chkMinBox,$chkCloseBox,$chkCtxHelp]
	Case 0	; reset
		Local $chksVec = 0
	Case Else
		MsgBox(0,"","Not defined yet")
		Return
	EndSwitch
	For $i = 0 to UBound($allChksVec)-1
		GUICtrlSetState($allChksVec[$i],$GUI_UNCHECKED)
	Next
	If IsArray($chksVec) Then
		For $i = 0 To UBound($chksVec)-1
			GUICtrlSetState($chksVec[$i],$GUI_CHECKED)
		Next
	EndIf
	$gParamStyles = $presetStylesAr[$nPres][0]
	$gParamExStyles = $presetStylesAr[$nPres][1]
	Show()
EndFunc

Func DoCheckBox($ctrlID,$nStyle,$nExStyle)
	If $nStyle<>0 Then
		If IsChecked($ctrlID) Then
			$gParamStyles = BitOR($gParamStyles,$nStyle)
		Else
			$gParamStyles = BitAND($gParamStyles,BitNOT($nStyle))
		EndIf
	EndIf
	If $nExStyle<>0 Then
		If IsChecked($ctrlID) Then
			$gParamExStyles = BitOR($gParamExStyles,$nExStyle)
		Else
			$gParamExStyles = BitAND($gParamExStyles,BitNOT($nExStyle))
		EndIf
	EndIf
	Show()
EndFunc

Func Show()
	Local $t,$n
	If $gParamStyles=BitOR($WS_MINIMIZEBOX, $WS_CAPTION, $WS_POPUP, $WS_SYSMENU) Then
		$t = "|-1"
	Else
		If BitAND($gParamStyles,BitOR($WS_MINIMIZEBOX, $WS_CAPTION, $WS_POPUP, $WS_SYSMENU)) _
			= BitOR($WS_MINIMIZEBOX, $WS_CAPTION, $WS_POPUP, $WS_SYSMENU) Then
			$t = "|$GUI_SS_DEFAULT_GUI"
			$n = BitAND($gParamStyles,BitNOT(BitOR($WS_MINIMIZEBOX, $WS_CAPTION, $WS_POPUP, $WS_SYSMENU)))
		Else
			$t = ""
			$n = $gParamStyles
		EndIf
		$t &= ConvertStylesToText($n)
	EndIf
	GUICtrlSetData($lstStyleParam,$t)
	$t = ConvertExStylesToText($gParamExStyles)
	GUICtrlSetData($lstExStyleParam,$t)

	Local $winInStyles
	$winInStyles = BitOR($gParamStyles,$WS_CLIPSIBLINGS)	 ; forced by AutoIt
	If BitAND($gParamStyles,BitOR($WS_MAXIMIZEBOX,$WS_SIZEBOX))<>0 Then	; forced by AutoIt
		$winInStyles = BitOR($winInStyles,$WS_SYSMENU)
	EndIf
	Local $winInExStyles = $gParamExStyles
	ShowAllStyles($winInStyles,$winInExStyles,$lstAIstylesInclForced)

	Local $winOutStyles,$winOutExStyles
	If ShowStatus($winOutStyles,$winOutExStyles) Then
		Local $winIgnored,$winAdded,$winExIgnored,$winExAdded
		CompareStyles($winInStyles,$winOutStyles,$winIgnored,$winAdded)
		CompareStyles($winInExStyles,$winOutExStyles,$winExIgnored,$winExAdded)
		ShowAllStyles($WinIgnored,$WinExIgnored,$lstStylesWinIgnored)
		ShowAllStyles($winAdded,$winExAdded,$lstStylesWinAdded)
		Local $nShowSecs = GUICtrlRead($inpShowTestSecs)
		If IsChecked($chkShowTestForm) Then ShowTestForm($nShowSecs)
	Else
		GUICtrlSetData($lstStylesWinIgnored,"")
		GUICtrlSetData($lstStylesWinAdded,"")
	EndIf
EndFunc
Func IsChecked($ctrlID)
	Return BitAND(GUICtrlRead($ctrlID),$GUI_CHECKED)=$GUI_CHECKED
EndFunc

Func ShowStatus(ByRef $winOutStyles,ByRef $winOutExStyles)
Local $n = 0,$hndl
	for $i = 1 to UBound($presetStylesAr,1)-1
		If $presetStylesAr[$i][0]=$gParamStyles And $presetStylesAr[$i][1]=$gParamExStyles Then
			$n = $i
			ExitLoop
		EndIf
	Next
	If IsChecked($chkFormHasParentProperty) Then
		$hndl = GUICreate("title",-200,-200,-200,-200,$gParamStyles,$gParamExStyles,$frmFormStyles)
	Else
		$hndl = GUICreate("title",-200,-200,-200,-200,$gParamStyles,$gParamExStyles)
	EndIf
	Local $bWorks = $hndl<>0 and @error=0
	if $bWorks Then
		$winOutStyles = _C_GetWindowLong($hndl,$GWL_STYLE)
		$winOutExStyles = _C_GetWindowLong($hndl,$GWL_EXSTYLE)
		GUIDelete($hndl)
		GUICtrlSetState($btnOK,$GUI_ENABLE)
	Else
		$winOutStyles = 0
		$winOutExStyles = 0
		GUICtrlSetState($btnOK,$GUI_DISABLE)
	EndIf
	Switch True
	Case $n>0
		GUICtrlSetData($lblStatus,"Preset " & $n)
		GUICtrlSetColor($lblStatus,0x007f00)	; green
	case $bWorks
		GUICtrlSetData($lblStatus,"Custom")
		GUICtrlSetColor($lblStatus,0x0000ff)	; blue
	Case Else
		GUICtrlSetData($lblStatus,"Failed")
		GUICtrlSetColor($lblStatus,0xff0000)	; red
	EndSwitch
	Return $bWorks
EndFunc
Func CompareStyles($in,$out,ByRef $lacks,ByRef $added)
	$lacks = 0
	$added = 0
	If $out=$in Then
		Return True
	Else
		For $iShft = 0 to 31
			Local $mask = BitShift(1,-$iShft)		; negative is left
			If BitAND($out,$mask)<>BitAND($in,$mask) Then
				If BitAND($out,$mask)<>0 Then
					$added = BitOR($added,$mask)
				Else
					$lacks = BitOR($lacks,$mask)
				EndIf
			EndIf
		Next
		Return False
	EndIf
EndFunc

Func ShowAllStyles($nStyles,$nExStyles,$ctrlID)
	Local $t=""
	If IsChecked($chkShowBitCombConsts) Then
		$t &= ConvertBitCombWinConstsToString($kBCCstylesAr,$nStyles)
	EndIf
	$t &= ConvertWinConstsToString($kStylesAr,$nStyles)
	If $nStyles<>0 Then
		MsgBox(0,"","Line "&@ScriptLineNumber&": Unknown style(s) 0x" & Hex($nStyles))
	EndIf
	If IsChecked($chkShowBitCombConsts) Then
		$t &= ConvertBitCombWinConstsToString($kBCCexStylesAr,$nExStyles)
	EndIf
	$t &= ConvertWinConstsToString($kExStylesAr,$nExStyles)
	If $nExStyles<>0 Then
		MsgBox(0,"","Line "&@ScriptLineNumber&": Unknown exStyle(s) 0x" & Hex($nExStyles))
	EndIf
	GUICtrlSetData($ctrlID,$t)
EndFunc

Func ConvertWinConstsToString($ar,ByRef $n)
	Local $t = ""
	For $i = 0 to UBound($ar,1)-1
		If ($n=0) Then ExitLoop
		If BitAND($n,$ar[$i][0])=$ar[$i][0] Then
			$t &= "|" & $ar[$i][1]
			$n = BitAND($n,BitNOT($ar[$i][0]))
		EndIf
	Next
	Return $t
EndFunc

; allow bits to be part of several bit-combination styles
Func ConvertBitCombWinConstsToString($ar,ByRef $n)
	Local $t = "",$doneConsts=0
	For $i = 0 to UBound($ar,1)-1
		If ($n=0) Then ExitLoop
		If BitAND($n,$ar[$i][0])=$ar[$i][0] Then
			$t &= "|" & $ar[$i][1]
			$doneConsts = BitOR($doneConsts,$n)
		EndIf
	Next
	$n = BitAND($n,BitNOT($doneConsts))

	Return $t
EndFunc

Func ShowTestForm($nShowSecs)
	Local $left,$top,$testForm
Opt("GUICloseOnESC",1)
	Local $hndl = GUICtrlGetHandle($gpTest)
	Local $vec = WinGetPos($hndl)	; left, top, width, height
	If BitAND($gParamExStyles,$WS_EX_MDICHILD)=$WS_EX_MDICHILD Then	; avoid odd left and top shift
		$left = $vec[0] - 98
		$top = $vec[1] - 125
	Else
		$left = $vec[0] + 5
		$top = $vec[1] + 15
	EndIf
	If IsChecked($chkFormHasParentProperty) Then
		$testForm = GUICreate("Test Form", $vec[2]-20, $vec[3]-50, $left, $top,$gParamStyles,$gParamExStyles,$frmFormStyles)
	Else
		$testForm = GUICreate("Test Form", $vec[2]-20, $vec[3]-50, $left, $top,$gParamStyles,$gParamExStyles)
	EndIf
	If BitAND($gParamStyles,$WS_SYSMENU)=0 Then
		Local $n = _C_GetWindowLong($testForm,$GWL_STYLE)
		$n = BitAND($n,BitNOT($WS_SYSMENU))
		_C_SetWindowLong($testForm,$GWL_STYLE,$n)
	EndIf
	If IsChecked($chkLayered) Then
		GUICtrlCreateLabel("Press Esc key to close", 8, 8, 164, 17,-1,$GUI_WS_EX_PARENTDRAG)
		_WinAPI_SetLayeredWindowAttributes($testForm, 0x010101)	; do not know why this makes form display!
	Else
		GUICtrlCreateLabel("Press Esc key to close", 8, 8, 164, 17)
	EndIf
	GUISetState(@SW_SHOW)
	If BitAND($gParamStyles,$WS_SYSMENU)=0 Then
		Local $n = _C_GetWindowLong($testForm,$GWL_STYLE)
		$n = BitAND($n,BitNOT($WS_SYSMENU))
		_C_SetWindowLong($testForm,$GWL_STYLE,$n)
	EndIf
	WinSetState($frmFormStyles,"",@SW_DISABLE)
	GUISwitch($TestForm)
	Local $stTime = TimerInit()
	While 1
		Local $nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE
				ExitLoop
		EndSwitch
		If TimerDiff($stTime)>$nShowSecs*1000 Then
			ExitLoop
		EndIf
	WEnd
Opt("GUICloseOnESC",0)
	WinSetState($frmFormStyles,"",@SW_ENABLE)
	GUISwitch($frmFormStyles)
	GUIDelete($testForm)
EndFunc

Func ConvertStylesToText($nStyles)
	Local $t=""
	If IsChecked($chkShowBitCombConsts) Then
		$t &= ConvertBitCombWinConstsToString($kBCCstylesAr,$nStyles)
	EndIf
	$t &= ConvertWinConstsToString($kStylesAr,$nStyles)
	If $nStyles<>0 Then
		MsgBox(0,"","Line "&@ScriptLineNumber&": Unknown style(s) 0x" & Hex($nStyles))
	EndIf
	Return $t
EndFunc

Func ConvertExStylesToText($nExStyles)
Local $t = ""
	If IsChecked($chkShowBitCombConsts) Then
		$t &= ConvertBitCombWinConstsToString($kBCCexStylesAr,$nExStyles)
	EndIf
	$t &= ConvertWinConstsToString($kExStylesAr,$nExStyles)
	If $nExStyles<>0 Then
		MsgBox(0,"","Line "&@ScriptLineNumber&": Unknown ExStyle(s) 0x" & Hex($nExStyles))
	EndIf
	Return $t
EndFunc

; Copied from WinAPI.au3
Func _C_GetWindowLong($hWnd, $iIndex)
	Local $sFuncName = "GetWindowLongW"
	If @AutoItX64 Then  $sFuncName = "GetWindowLongPtrW"
	Local $aResult = DllCall("user32.dll", "long_ptr", $sFuncName, "hwnd", $hWnd, "int", $iIndex)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aResult[0]
EndFunc   ;==>_C_GetWindowLong

; Copied from WinAPI.au3
Func _C_SetWindowLong($hWnd, $iIndex, $iValue)
	_C_SetLastError(0)	; as suggested in MSDN
	Local $sFuncName = "SetWindowLongW"
	If @AutoItX64 Then  $sFuncName = "SetWindowLongPtrW"
	Local $aResult = DllCall("user32.dll", "long_ptr", $sFuncName, "hwnd", $hWnd, "int", $iIndex, "long_ptr", $iValue)
	If @error Then Return SetError(@error, @extended, 0)
	Return $aResult[0]
EndFunc   ;==>_C_SetWindowLong

; Copied from WinAPIError.au3
Func _C_SetLastError($iErrCode, $curErr=@error, $curExt=@extended)
	DllCall("kernel32.dll", "none", "SetLastError", "dword", $iErrCode)
	Return SetError($curErr, $curExt)
EndFunc   ;==>_C_SetLastError
